## qtcreator 4.13.2

=== debian/changelog ===
qtcreator (4.13.2-1) unstable; urgency=medium

  * New upstream release.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Fri, 02 Oct 2020 20:00:02 -0300

qtcreator (4.13.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Fri, 18 Sep 2020 08:06:04 +0200

qtcreator (4.13.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - load_clanglazy.patch: drop, clazy can be called only as external tool
  * Add the libyaml-cpp-dev build dependency to use the system yaml-cpp instead
    of the embedded copy.
  * Suggest meson for the new meson plugin.
  * Pass KSYNTAXHIGHLIGHTING_INCLUDE_DIR with the path of the includes of
    KF5SyntaxHighlighting, so they can be found on any architecture (and not
    only on Linux).
  * Install desktop and AppStream files also on non-Linux architectures;
    patch desktop_nonlinux.diff.

 -- Pino Toscano <pino@debian.org>  Thu, 27 Aug 2020 10:00:26 +0200

qtcreator (4.12.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Use the default LLVM/clang Debian versions, rather than hardcoding 8.
    Hopefully qtcreator will properly support newer LLVM versions fast enough.
    (Closes: #966007)
    - switch the libclang-8-dev build dependency to libclang-dev >= 8
    - switch the llvm-8-dev build dependency to llvm-dev >= 8
    - get the LLVM root using llvm-config
  * Switch the generic clang recommend to a dependency of the exact clang-N
    used to build (Closes: #919860, #952718) (LP: #1890434, #1877927)
    - add the clang build dependency to get the used clang executable
  * Drop the Debian man page, as it is outdated, and it offers no useful
    information.
  * Force the version of libqt5designercomponents5 as dependency to be at least
    the same as used during the build. (Closes: #966169)
  * Remove the kate-data suggest, as it does not exist anymore; syntax
    highlighting files are already provided by KF5SyntaxHighlighting.

 -- Pino Toscano <pino@debian.org>  Wed, 19 Aug 2020 19:00:23 +0200

qtcreator (4.12.3-3) unstable; urgency=medium

  * Team upload.
  * Undefine mips macro to fix FTBFS on mipsel.

 -- Dmitry Shachnev <mitya57@debian.org>  Fri, 26 Jun 2020 19:39:40 +0300

qtcreator (4.12.3-2) unstable; urgency=medium

  * Team upload.
  * Add a patch to fix perfparser build on big endian systems.

 -- Dmitry Shachnev <mitya57@debian.org>  Thu, 25 Jun 2020 19:40:29 +0300

qtcreator (4.12.3-1) unstable; urgency=medium

  * Team upload.

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * New upstream release.
  * Refresh detect_ccache_executables.patch.
  * Update debian/copyright.
  * Remove detect_ccache_executables.patch, it's present in this version.
  * Adapt load_clanglazy.patch, it hopefully still works.
  * Drop botan dependency, as now Qt Creator uses OpenSSH tools
    (Closes: #955465). Thanks Michael Weghorn for the bug report!
  * Use system liblitehtml-dev (Closes: #956341).

  [ Dmitry Shachnev ]
  * Install only qtcreator’s own docs, not also QBS docs.
  * Remove qbs-dev build-dependency, it is no longer used.
  * Add licenses for AppStream metadata to debian/copyright.
  * Remove libqt5webkit5-dev build-dependency, unused since 4.2.0.
  * Bump Qt build-dependencies to 5.11.0.

  [ Enrico Zini ]
  * Added libdw-dev build-dependency to make sure perfparser is built.
  * Further update load_clanglazy.patch for Qt Creator 4.12.

 -- Dmitry Shachnev <mitya57@debian.org>  Thu, 25 Jun 2020 11:04:48 +0300

=== debian/control ===
Source: qtcreator
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Adam Majer <adamm@zombino.com>,
           Jeremy Lainé <jeremy.laine@m4x.org>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Simon Quigley <tsimonq2@debian.org>
Build-Depends: clang (>= 1:8~),
               debhelper-compat (= 12),
               libclang-dev (>= 1:8~),
               libdw-dev,
               libicu-dev,
               libjs-jquery,
               libkf5syntaxhighlighting-dev,
               liblitehtml-dev,
               libqt5opengl5-dev (>= 5.11.0~),
               libqt5serialport5-dev (>= 5.11.0~),
               libqt5sql5-sqlite (>= 5.11.0~),
               libqt5x11extras5-dev (>= 5.11.0~),
               libyaml-cpp-dev (>= 0.5~),
               llvm-dev (>= 1:8~),
               pkg-config,
               qml-module-qtquick-controls (>= 5.11.0~),
               qml-module-qtquick2 (>= 5.11.0~),
               qtbase5-dev (>= 5.11.0~),
               qtbase5-private-dev (>= 5.11.0~),
               qtdeclarative5-dev (>= 5.11.0~),
               qtdeclarative5-private-dev (>= 5.11.0~),
               qtscript5-dev (>= 5.11.0~),
               qttools5-dev (>= 5.11.0~),
               qttools5-dev-tools (>= 5.11.0~),
               qttools5-private-dev (>= 5.11.0~),
               qtxmlpatterns5-dev-tools (>= 5.11.0~),
               zlib1g-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qtcreator

Package: qtcreator
Architecture: any
Depends: libqt5sql5-sqlite,
         qml-module-qtqml-models2,
         qml-module-qtquick-controls (>= 5.5.0~),
         qml-module-qtquick2 (>= 5.5.0~),
         qtchooser,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${qtcreator:clang},
         ${shlibs:Depends}
Recommends: clang-tidy,
            gdb,
            make,
            qmlscene,
            qt5-doc,
            qt5-qmltooling-plugins,
            qtbase5-dev-tools,
            qtcreator-doc,
            qtdeclarative5-dev-tools,
            qttools5-dev-tools,
            qttranslations5-l10n,
            qtxmlpatterns5-dev-tools,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5), cmake, g++, git, meson, subversion, valgrind
Breaks: qtcreator-data (<< 4.5.2-2~)
Replaces: qtcreator-data (<< 4.5.2-2~)
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: qt5-doc
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export QT_SELECT := qt5
export LLVM_INSTALL_DIR = $(shell llvm-config --prefix)

# Upstream changelog
upstream_changes := $(wildcard dist/changes-*)

%:
	dh $@ --builddirectory=builddir

override_dh_auto_configure:
	dh_auto_configure --buildsystem=qmake -- \
		-recursive \
		QBS_INSTALL_DIR=/usr \
		LLVM_INSTALL_DIR="$(LLVM_INSTALL_DIR)" \
		KSYNTAXHIGHLIGHTING_LIB_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/" \
		KSYNTAXHIGHLIGHTING_INCLUDE_DIR="/usr/include/KF5/KSyntaxHighlighting/" \
		CONFIG+="disable_external_rpath" \
		$(CURDIR) IDE_LIBRARY_BASENAME=lib/$(DEB_HOST_MULTIARCH) IDE_PACKAGE_MODE=1 $(extra_configure_opts)

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp/usr
ifneq (,$(filter qtcreator-doc, $(shell dh_listpackages)))
	dh_auto_build -- qch_docs
	dh_auto_build -- install_inst_qch_docs install_inst_html_docs INSTALL_ROOT=$(CURDIR)/debian/tmp/usr
endif

	# Do not install the file, we better symlink it.
	rm -vf debian/tmp/usr/share/qtcreator/debugger/LICENSE.LGPL

	# Not needed
	rm debian/tmp/usr/bin/qtcreator.sh

override_dh_missing:
	dh_missing --fail-missing

override_dh_installdocs:
	dh_installdocs -pqtcreator-data $(upstream_changes)
	dh_installdocs --remaining-packages

override_dh_shlibdeps:
	echo 'libQt5DesignerComponents 5 libqt5designercomponents5 (>= $(shell dpkg-query -f '$${Version}' -W libqt5designercomponents5 | sed -e 's/-[^-]*$$//')~)' > debian/shlibs.local
	dh_shlibdeps -l$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator:\
	$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/plugins/QtProject
	rm debian/shlibs.local

override_dh_gencontrol-arch:
	dh_gencontrol -a -- -V'qtcreator:clang=$(shell dpkg -S "$(shell realpath $(shell env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang))" | cut -d: -f1)'

## qtcreator 4.14.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

## Add paths to check for cmake modules:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(FeatureSummary)
include(QtCreatorIDEBranding RESULT_VARIABLE IDE_BRANDING_FILE)
include(QtCreatorTranslations)
include(QtCreatorDocumentation)
include(QtCreatorAPI)

set(IDE_REVISION FALSE CACHE BOOL "Marks the presence of IDE revision string.")
set(IDE_REVISION_STR "" CACHE STRING "The IDE revision string.")
set(IDE_REVISION_URL "" CACHE STRING "The IDE revision Url string.")

mark_as_advanced(IDE_REVISION IDE_REVISION_STR IDE_REVISION_URL)

project(QtCreator VERSION ${IDE_VERSION})

# Force C++ standard, do not fall back, do not use compiler extensions
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(WITH_TESTS "Build Tests" OFF)
add_feature_info("Build tests" ${WITH_TESTS} "")
option(WITH_DEBUG_CMAKE "Enabled CMake project debugging functionality (e.g. source file disk checking)" OFF)
option(BUILD_WITH_PCH "Build with precompiled headers" ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Set up Qt stuff:
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if (WITH_TESTS)
  set(QT_TEST_COMPONENT Test)
  set(IMPLICIT_DEPENDS Qt5::Test)
endif()

find_package(Qt5
  ${IDE_QT_VERSION_MIN}
  COMPONENTS Concurrent Core Gui Network PrintSupport Qml Quick
    QuickWidgets Sql Widgets Xml Core5Compat ${QT_TEST_COMPONENT}
  REQUIRED
)
if (Qt5_VERSION VERSION_LESS 6.0.0)
  install(TARGETS Qt6Core5Compat EXPORT QtCreator)
endif()
find_package(Qt5 COMPONENTS LinguistTools QUIET)
find_package(Qt5 COMPONENTS Designer DesignerComponents Help SerialPort Svg Tools QUIET)

find_package(Threads)
find_package(Clang QUIET)
find_package(KF5SyntaxHighlighting QUIET)

function (set_if_target var target)
   if (TARGET "${target}")
     set(_result ON)
   else()
     set(_result OFF)
   endif()
   set(${var} "${_result}" PARENT_SCOPE)
endfunction()

set_if_target(_has_svg_target Qt5::Svg)
option(ENABLE_SVG_SUPPORT "Enable SVG support" "${_has_svg_target}")

# specify standards conformance mode to MSVC 2017 and later
if (MSVC AND MSVC_VERSION GREATER_EQUAL 1910)
    add_compile_options(/permissive-)
endif()

add_library(OptionalSvg INTERFACE)
if (TARGET Qt5::Svg AND ENABLE_SVG_SUPPORT)
  target_link_libraries(OptionalSvg INTERFACE Qt5::Svg)
else()
  target_compile_definitions(OptionalSvg INTERFACE QT_NO_SVG)
endif()
install(TARGETS OptionalSvg EXPORT QtCreator)

if (APPLE)
  find_library(FWCoreFoundation CoreFoundation)
  find_library(FWCoreServices CoreServices)
  find_library(FWFoundation Foundation)
  find_library(FWAppKit AppKit)
  find_library(FWIOKit IOKit)
  find_library(FWSecurity Security)
  find_library(FWSystemConfiguration SystemConfiguration)
  find_library(FWWebKit WebKit)
endif()

if (WITH_TESTS)
  enable_testing()
endif()

if (UNIX)
  add_subdirectory(bin)
endif()

add_subdirectory(src)
add_subdirectory(share)

if (WITH_TESTS)
  add_subdirectory(tests)
endif()

add_subdirectory(doc)

find_package(PythonInterp)
if (NOT PYTHONINTERP_FOUND)
  message("No python interpreter found, skipping \"Dependencies\" install component.")
else()
  get_target_property(_qmake_binary Qt5::qmake IMPORTED_LOCATION)
  set(_llvm_arg)
  if (LLVM_INSTALL_PREFIX)
    set(_llvm_arg "--llvm \"${LLVM_INSTALL_PREFIX}\"")
  endif()
  set(_elfutils_arg)
  if (ELFUTILS_INCLUDE_DIR)
    get_filename_component(_elfutils_path ${ELFUTILS_INCLUDE_DIR} DIRECTORY)
    set(_elfutils_arg "--elfutils \"${_elfutils_path}\"")
  endif()
  install(CODE "
      execute_process(COMMAND
        \"${PYTHON_EXECUTABLE}\"
        \"${CMAKE_CURRENT_LIST_DIR}/scripts/deployqt.py\"
        ${_llvm_arg}
        ${_elfutils_arg}
        \"\${CMAKE_INSTALL_PREFIX}/${IDE_APP_PATH}/${IDE_APP_TARGET}\"
        \"${_qmake_binary}\"
        COMMAND_ECHO STDOUT
        )
    "
    COMPONENT Dependencies
    EXCLUDE_FROM_ALL
  )
endif()

feature_summary(INCLUDE_QUIET_PACKAGES WHAT
  PACKAGES_FOUND PACKAGES_NOT_FOUND
  ENABLED_FEATURES DISABLED_FEATURES
)

=== src/libs/cplusplus/CMakeLists.txt ===
# TODO: Support static build, currently being done with CPLUSPLUS_BUILD_STATIC_LIB
#       -- if really needed that is.
# TODO: Make Qt5::Gui optional -- if really needed that is.

add_qtc_library(CPlusPlus
  DEPENDS Utils Qt5::Concurrent
  DEFINES CPLUSPLUS_BUILD_LIB
  PUBLIC_DEPENDS 3rd_cplusplus Qt5::Gui
  SOURCES
    ASTParent.cpp ASTParent.h
    ASTPath.cpp ASTPath.h
    AlreadyConsideredClassContainer.h
    BackwardsScanner.cpp BackwardsScanner.h
    CppDocument.cpp CppDocument.h
    CppRewriter.cpp CppRewriter.h
    DependencyTable.cpp DependencyTable.h
    DeprecatedGenTemplateInstance.cpp DeprecatedGenTemplateInstance.h
    ExpressionUnderCursor.cpp ExpressionUnderCursor.h
    FastPreprocessor.cpp FastPreprocessor.h
    FindUsages.cpp FindUsages.h
    Icons.cpp Icons.h
    LookupContext.cpp LookupContext.h
    LookupItem.cpp LookupItem.h
    Macro.cpp Macro.h
    MatchingText.cpp MatchingText.h
    NamePrettyPrinter.cpp NamePrettyPrinter.h
    Overview.cpp Overview.h
    PPToken.cpp PPToken.h
    PreprocessorClient.cpp PreprocessorClient.h
    PreprocessorEnvironment.cpp PreprocessorEnvironment.h
    ResolveExpression.cpp ResolveExpression.h
    SimpleLexer.cpp SimpleLexer.h
    SnapshotSymbolVisitor.cpp SnapshotSymbolVisitor.h
    SymbolNameVisitor.cpp SymbolNameVisitor.h
    TypeOfExpression.cpp TypeOfExpression.h
    TypePrettyPrinter.cpp TypePrettyPrinter.h
    cppmodelmanagerbase.cpp cppmodelmanagerbase.h
    findcdbbreakpoint.cpp findcdbbreakpoint.h
    pp-cctype.h pp-engine.cpp
    pp-engine.h pp-scanner.cpp
    pp-scanner.h
    pp.h
)

=== src/plugins/clangformat/CMakeLists.txt ===
add_qtc_plugin(ClangFormat
  CONDITION TARGET libclang AND LLVM_PACKAGE_VERSION VERSION_GREATER_EQUAL 10.0.0 AND QTC_CLANG_BUILDMODE_MATCH
  DEPENDS Utils Qt5::Widgets clangFormat
  INCLUDES "${CLANG_INCLUDE_DIRS}"
  PLUGIN_DEPENDS Core TextEditor CppEditor CppTools ProjectExplorer
  SOURCES
    clangformatbaseindenter.cpp clangformatbaseindenter.h
    clangformatchecks.ui
    clangformatconfigwidget.cpp clangformatconfigwidget.h clangformatconfigwidget.ui
    clangformatconstants.h
    clangformatindenter.cpp clangformatindenter.h
    clangformatplugin.cpp clangformatplugin.h
    clangformatsettings.cpp clangformatsettings.h
    clangformatutils.cpp clangformatutils.h
)

=== src/plugins/genericprojectmanager/CMakeLists.txt ===
if (WITH_TESTS)
  set(TST_COMPONENT CppEditor)
endif()

add_qtc_plugin(GenericProjectManager
  PLUGIN_DEPENDS Core ProjectExplorer QtSupport TextEditor ${TST_COMPONENT}
  PLUGIN_RECOMMENDS CppTools
  SOURCES ${TEST_SOURCES}
    filesselectionwizardpage.cpp filesselectionwizardpage.h
    genericbuildconfiguration.cpp genericbuildconfiguration.h
    genericmakestep.cpp genericmakestep.h
    genericproject.cpp genericproject.h
    genericprojectconstants.h
    genericprojectfileseditor.cpp genericprojectfileseditor.h
    genericprojectplugin.cpp genericprojectplugin.h
    genericprojectwizard.cpp genericprojectwizard.h
)

=== src/tools/qml2puppet/CMakeLists.txt ===
set(SRCDIR "${PROJECT_SOURCE_DIR}/share/qtcreator/qml/qmlpuppet")

set(DESTDIR "${IDE_LIBEXEC_PATH}")
if (APPLE)
  string(APPEND DESTDIR "/qmldesigner")
endif()

add_qtc_library(qml2puppet_static
  STATIC
  DEPENDS
  Qt5::CorePrivate Qt5::Widgets
  PUBLIC_INCLUDES "${SRCDIR}/interfaces"
  SOURCES_PREFIX "${SRCDIR}/interfaces"
  SOURCES
    commondefines.h
    nodeinstanceclientinterface.h
    nodeinstanceglobal.h
    nodeinstanceserverinterface.cpp nodeinstanceserverinterface.h
)

extend_qtc_library(qml2puppet_static
  PUBLIC_INCLUDES "${SRCDIR}/types"
  SOURCES "${SRCDIR}/types/enumeration.h"
)

extend_qtc_library(qml2puppet_static
  PUBLIC_INCLUDES "${SRCDIR}/container"
  SOURCES_PREFIX "${SRCDIR}/container"
  SOURCES
    addimportcontainer.cpp addimportcontainer.h
    idcontainer.cpp idcontainer.h
    imagecontainer.cpp imagecontainer.h
    informationcontainer.cpp informationcontainer.h
    instancecontainer.cpp instancecontainer.h
    mockuptypecontainer.cpp mockuptypecontainer.h
    propertyabstractcontainer.cpp propertyabstractcontainer.h
    propertybindingcontainer.cpp propertybindingcontainer.h
    propertyvaluecontainer.cpp propertyvaluecontainer.h
    reparentcontainer.cpp reparentcontainer.h
    sharedmemory.h
)

extend_qtc_library(qml2puppet_static
  CONDITION UNIX
  SOURCES_PREFIX "${SRCDIR}/container"
  SOURCES
    sharedmemory_unix.cpp
)

extend_qtc_library(qml2puppet_static
  CONDITION NOT UNIX
  SOURCES_PREFIX "${SRCDIR}/container"
  SOURCES
    sharedmemory_qt.cpp
)

extend_qtc_library(qml2puppet_static
  PUBLIC_INCLUDES "${SRCDIR}/commands"
  SOURCES_PREFIX "${SRCDIR}/commands"
  SOURCES
    changeauxiliarycommand.cpp changeauxiliarycommand.h
    changebindingscommand.cpp changebindingscommand.h
    changefileurlcommand.cpp changefileurlcommand.h
    changeidscommand.cpp changeidscommand.h
    changenodesourcecommand.cpp changenodesourcecommand.h
    changestatecommand.cpp changestatecommand.h
    changevaluescommand.cpp changevaluescommand.h
    childrenchangedcommand.cpp childrenchangedcommand.h
    clearscenecommand.cpp clearscenecommand.h
    completecomponentcommand.cpp completecomponentcommand.h
    componentcompletedcommand.cpp componentcompletedcommand.h
    createinstancescommand.cpp createinstancescommand.h
    createscenecommand.cpp createscenecommand.h
    changepreviewimagesizecommand.cpp changepreviewimagesizecommand.h
    changelanguagecommand.cpp changelanguagecommand.h
    debugoutputcommand.cpp debugoutputcommand.h
    endpuppetcommand.cpp endpuppetcommand.h
    informationchangedcommand.cpp informationchangedcommand.h
    pixmapchangedcommand.cpp pixmapchangedcommand.h
    puppetalivecommand.cpp puppetalivecommand.h
    removeinstancescommand.cpp removeinstancescommand.h
    removepropertiescommand.cpp removepropertiescommand.h
    removesharedmemorycommand.cpp removesharedmemorycommand.h
    reparentinstancescommand.cpp reparentinstancescommand.h
    statepreviewimagechangedcommand.cpp statepreviewimagechangedcommand.h
    synchronizecommand.cpp synchronizecommand.h
    tokencommand.cpp tokencommand.h
    changeselectioncommand.cpp changeselectioncommand.h
    update3dviewstatecommand.cpp update3dviewstatecommand.h
    puppettocreatorcommand.cpp puppettocreatorcommand.h
    inputeventcommand.cpp inputeventcommand.h
    view3dactioncommand.cpp view3dactioncommand.h
    requestmodelnodepreviewimagecommand.cpp requestmodelnodepreviewimagecommand.h
    valueschangedcommand.cpp
    captureddatacommand.h
    scenecreatedcommand.h
)

add_qtc_executable(qml2puppet
  DEPENDS
    Qt5::CorePrivate Qt5::Widgets Qt5::QmlPrivate
    Qt5::QuickPrivate Qt5::Network Qt5::GuiPrivate
    qml2puppet_static
  SOURCES
    "${SRCDIR}/qml2puppet/qml2puppetmain.cpp"
    "${SRCDIR}/qmlpuppet.qrc"
  DESTINATION ${DESTDIR}
)

extend_qtc_executable(qml2puppet
  CONDITION UNIX AND (NOT APPLE)
  DEPENDS rt
)

extend_qtc_executable(qml2puppet
  SOURCES_PREFIX "${SRCDIR}/instances"
  SOURCES
    nodeinstanceclientproxy.cpp nodeinstanceclientproxy.h
)

find_package(Qt5 5.15.0 COMPONENTS Quick3D QUIET)
extend_qtc_executable(qml2puppet
  CONDITION TARGET Qt5::Quick3D
  FEATURE_INFO "Qt Quick 3D support"
  DEPENDS Qt5::Quick3D Qt5::Quick3DPrivate
  DEFINES QUICK3D_MODULE

  SOURCES_PREFIX "${SRCDIR}/qml2puppet/editor3d"
  SOURCES
    generalhelper.cpp generalhelper.h
    mousearea3d.cpp mousearea3d.h
    camerageometry.cpp camerageometry.h
    lightgeometry.cpp lightgeometry.h
    gridgeometry.cpp gridgeometry.h
    selectionboxgeometry.cpp selectionboxgeometry.h
    linegeometry.cpp linegeometry.h
    icongizmoimageprovider.cpp icongizmoimageprovider.h
)

extend_qtc_executable(qml2puppet
  CONDITION Qt5_VERSION VERSION_GREATER_EQUAL 6.0.0

  SOURCES_PREFIX "${SRCDIR}/qml2puppet/editor3d/qt5compat"
  SOURCES
    qquick3darealight.cpp qquick3darealight_p.h
)

extend_qtc_executable(qml2puppet
  SOURCES_PREFIX "${SRCDIR}/qml2puppet/iconrenderer"
  SOURCES
    iconrenderer.cpp iconrenderer.h
)

extend_qtc_executable(qml2puppet
  SOURCES_PREFIX "${SRCDIR}/qml2puppet/instances"
  SOURCES
    anchorchangesnodeinstance.cpp anchorchangesnodeinstance.h
    behaviornodeinstance.cpp behaviornodeinstance.h
    childrenchangeeventfilter.cpp childrenchangeeventfilter.h
    componentnodeinstance.cpp componentnodeinstance.h
    dummycontextobject.cpp dummycontextobject.h
    dummynodeinstance.cpp dummynodeinstance.h
    layoutnodeinstance.cpp layoutnodeinstance.h
    nodeinstanceserver.cpp nodeinstanceserver.h
    nodeinstancesignalspy.cpp nodeinstancesignalspy.h
    objectnodeinstance.cpp objectnodeinstance.h
    positionernodeinstance.cpp positionernodeinstance.h
    qmlpropertychangesnodeinstance.cpp qmlpropertychangesnodeinstance.h
    qmlstatenodeinstance.cpp qmlstatenodeinstance.h
    qmltransitionnodeinstance.cpp qmltransitionnodeinstance.h
    qt3dpresentationnodeinstance.cpp qt3dpresentationnodeinstance.h
    qt5informationnodeinstanceserver.cpp qt5informationnodeinstanceserver.h
    qt5nodeinstanceclientproxy.cpp qt5nodeinstanceclientproxy.h
    qt5nodeinstanceserver.cpp qt5nodeinstanceserver.h
    qt5previewnodeinstanceserver.cpp qt5previewnodeinstanceserver.h
    qt5rendernodeinstanceserver.cpp qt5rendernodeinstanceserver.h
    qt5testnodeinstanceserver.cpp qt5testnodeinstanceserver.h
    quick3dnodeinstance.cpp quick3dnodeinstance.h
    quick3dtexturenodeinstance.cpp quick3dtexturenodeinstance.h
    quickitemnodeinstance.cpp quickitemnodeinstance.h
    servernodeinstance.cpp servernodeinstance.h
    qt5capturepreviewnodeinstanceserver.cpp qt5capturepreviewnodeinstanceserver.h
    nodeinstanceserverdispatcher.cpp nodeinstanceserverdispatcher.h
    capturenodeinstanceserverdispatcher.cpp capturenodeinstanceserverdispatcher.h
    qt5captureimagenodeinstanceserver.cpp qt5captureimagenodeinstanceserver.h
)

extend_qtc_executable(qml2puppet
  SOURCES_PREFIX "${SRCDIR}/types"
  SOURCES
    enumeration.h
)

extend_qtc_executable(qml2puppet
  SOURCES_PREFIX "${SRCDIR}/qmlprivategate"
  SOURCES
    designersupportdelegate.h
    qmlprivategate_56.cpp qmlprivategate.h
)

=== debian/changelog ===
qtcreator (4.14.0-lnd.3) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 18:10:15 +0800

qtcreator (4.14.0-lnd.2) unstable; urgency=medium

  * Fix abi recognized error for mips64 and loongarch64

 -- CaoHuixiong <caohuixiong@loongson.cn>  Thu, 13 May 2021 17:10:38 UTC

qtcreator (4.14.0-lnd.1) unstable; urgency=medium

  * Port qtcreator for loongarch.

 -- CaoHuixiong <caohuixiong@loongson.cn>  Thu, 21 Jan 2021 06:57:38 UTC

qtcreator (4.14.0-4) unstable; urgency=medium

  * Team upload.
  * Build the documentation in addition to what dh_auto_build does, not
    replacing altogether the -indep step; otherwise dh_auto_build is not
    run in -indep build, and thus not all the data files are available.

 -- Pino Toscano <pino@debian.org>  Fri, 15 Jan 2021 20:59:13 +0100

qtcreator (4.14.0-3) unstable; urgency=medium

  * Team upload.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
    - stop passing --fail-missing to dh_missing, as it is the default now
  * Drop debian/README.source, as it does not provide useful information.
  * Include /usr/share/dpkg/architecture.mk instead of manually querying
    dpkg-architecture for DEB_HOST_MULTIARCH.
  * Update watch file:
    - bump to v4, no changes required
    - drop repack and compress options, as the original tarball is fine
  * Add Repository, and Repository-Browse to debian/upstream/metadata.
  * Add the configuration for the CI on salsa.
  * Backport upstream commit 86348d562214a27574ddbd65825414ae7e731438 to fix
    the paths to Clang include & library directories; patch
    upstream_cmake-build-Fix-fallback-LLVM-Clang-paths.patch. (Closes: #979577)
  * Backport upstream commit c81baf1a9cc938a283f6c52c8fd10bab84183391 to set
    installation paths using the GNUInstallDirs module of CMake; patch
    upstream_cmake-build-Use-GNUInstallDirs-for-installation-path.patch
    - remove the majority of debian_paths.diff, leaving only the change to the
      documentation path
  * Require the same version of the clang-N used for the build: this is because
    creator hardcodes the clang version and its include path, so we should not
    let an older clang than the build one be usable.
  * Backport upstream commit c650c9473db32fc2197a32017b0ef3406cf75280 to not
    install KSyntaxHighlighting files from the embedded copy; patch
    upstream_cmake-build-Don-t-install-highlighting-files-when-us.patch
    - drop their removal from rules
  * Lazy-evaluate the list of dist/changes-* (for dh_installdocs).

 -- Pino Toscano <pino@debian.org>  Fri, 15 Jan 2021 20:20:31 +0100

qtcreator (4.14.0-2) unstable; urgency=medium

  * Team upload.
  * Build qtcreator with cmake instead of qmake, as it is supported (and
    encouraged) by upstream:
    - adapt the installation paths to the Debian locations; patch
      debian_paths.diff
    - add the cmake build dependency
    - drop all the other patches related to qmake bits that are not needed
      anymore: rpath_nonlinux.diff, remove_libexec.diff,
      fix_documentation_path.diff, and desktop_nonlinux.diff
    - adapt rules:
      - force the cmake buildsystem, as dh prefers qmake when autodetecting
      - pass -DBUILD_QBS=OFF to not build the embedded copy of qbs
      - enable, build, and install the documentation only when qtcreator-doc
        is built
      - remove duplicated installed files to keep qtcreator-data.install simple
      - export QTC_BUILD_PLUGIN_HELLOWORLD=FALSE to not build the HelloWorld
        plugin (replaces the qmake variable IDE_PACKAGE_MODE=1)
    - update install files
    - create compatibility symlinks for the moved paths of the HTML docs
  * Drop all the LICENSE.LGPL symlinks we create, as those license files are
    not installed anymore.
  * Remove extra executable permissions from qmldir files.
  * Update lintian overrides.
  * Disable shlibs on the internal libraries, as it is pointless.
  * Add the libqt5svg5-dev, and libzstd-dev build dependencies for extra
    features.
  * Drop the unapplied patches always_autotect_qt_versions, and
    fix_qt_version_autodetection.diff: they were added many years ago, with
    not many details on what was the actual problem or whether it was reported
    upstream; they have not been applied for a year and we got no reports about
    them, so drop them for good.
  * Export QTC_BUILD_PLUGIN_CLANGFORMAT=FALSE to disable the build of the
    ClangFormat plugin, as it requires clang-format with a patch not accepted
    yet (Closes: #939825) (LP: #1876436); see:
    - https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=939825#49
    - https://bugreports.qt.io/browse/QTCREATORBUG-22923

 -- Pino Toscano <pino@debian.org>  Wed, 23 Dec 2020 09:10:13 +0100

qtcreator (4.14.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump the Qt packages to 5.14.0
    - bump the LLVM/clang packages to 10
  * Update the patches:
    - remove_libexec.diff: refresh
    - fix_documentation_path.diff: refresh
    - perfparser_big_endian.patch: drop, fixed upstream
    - perfparser_undef_mips.patch: drop, fixed upstream
    - desktop_nonlinux.diff: refresh

 -- Pino Toscano <pino@debian.org>  Thu, 17 Dec 2020 22:47:49 +0100

qtcreator (4.13.3-1) unstable; urgency=medium

  * Team upload.

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Make the mime types defined in debian/Nokia-QtCreator.xml a sub class of
    text/plain. This makes other editors like KDevelop not open them in the hex
    editor. Thanks Sune Vuorela for the patch!

  [ Pino Toscano ]
  * New upstream release.
  * Bump Standards-Version to 4.5.1, no changes required.

 -- Pino Toscano <pino@debian.org>  Fri, 20 Nov 2020 15:35:24 +0100

=== debian/control ===
--- 
+++ 
@@ -6,34 +6,35 @@
            Jeremy Lainé <jeremy.laine@m4x.org>,
            Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
            Simon Quigley <tsimonq2@debian.org>
-Build-Depends: clang (>= 1:8~),
-               debhelper-compat (= 12),
-               libclang-dev (>= 1:8~),
+Build-Depends: clang,
+               cmake (>= 3.10~),
+               debhelper-compat (= 11),
+               libclang-dev,
                libdw-dev,
                libicu-dev,
                libjs-jquery,
-               libkf5syntaxhighlighting-dev,
-               liblitehtml-dev,
-               libqt5opengl5-dev (>= 5.11.0~),
-               libqt5serialport5-dev (>= 5.11.0~),
-               libqt5sql5-sqlite (>= 5.11.0~),
-               libqt5x11extras5-dev (>= 5.11.0~),
+               libqt5opengl5-dev (>= 5.14.0~),
+               libqt5serialport5-dev (>= 5.14.0~),
+               libqt5sql5-sqlite (>= 5.14.0~),
+               libqt5svg5-dev (>= 5.14.0~),
+               libqt5x11extras5-dev (>= 5.14.0~),
                libyaml-cpp-dev (>= 0.5~),
-               llvm-dev (>= 1:8~),
+               libzstd-dev,
+               llvm-dev,
                pkg-config,
-               qml-module-qtquick-controls (>= 5.11.0~),
-               qml-module-qtquick2 (>= 5.11.0~),
-               qtbase5-dev (>= 5.11.0~),
-               qtbase5-private-dev (>= 5.11.0~),
-               qtdeclarative5-dev (>= 5.11.0~),
-               qtdeclarative5-private-dev (>= 5.11.0~),
-               qtscript5-dev (>= 5.11.0~),
-               qttools5-dev (>= 5.11.0~),
-               qttools5-dev-tools (>= 5.11.0~),
-               qttools5-private-dev (>= 5.11.0~),
-               qtxmlpatterns5-dev-tools (>= 5.11.0~),
+               qml-module-qtquick-controls (>= 5.14.0~),
+               qml-module-qtquick2 (>= 5.14.0~),
+               qtbase5-dev (>= 5.14.0~),
+               qtbase5-private-dev (>= 5.14.0~),
+               qtdeclarative5-dev (>= 5.14.0~),
+               qtdeclarative5-private-dev (>= 5.14.0~),
+               qtscript5-dev (>= 5.14.0~),
+               qttools5-dev (>= 5.14.0~),
+               qttools5-dev-tools (>= 5.14.0~),
+               qttools5-private-dev (>= 5.14.0~),
+               qtxmlpatterns5-dev-tools (>= 5.14.0~),
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://doc.qt.io/qt-5/topics-app-development.html
 Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git
@@ -88,15 +89,15 @@
 Description: application data for Qt Creator IDE
  This package contains architecture-independent data for Qt Creator IDE.
 
-Package: qtcreator-doc
-Architecture: all
-Multi-Arch: foreign
-Section: doc
-Depends: ${misc:Depends}
-Suggests: qt5-doc
-Description: documentation for Qt Creator IDE
- Qt Creator is a cross-platform integrated development environment (IDE)
- designed to make development with the Qt application framework faster
- and easier.
- .
- This package contains documentation for Qt Creator IDE.
+#Package: qtcreator-doc
+#Architecture: all
+#Multi-Arch: foreign
+#Section: doc
+#Depends: ${misc:Depends}
+#Suggests: qt5-doc
+#Description: documentation for Qt Creator IDE
+# Qt Creator is a cross-platform integrated development environment (IDE)
+# designed to make development with the Qt application framework faster
+# and easier.
+# .
+# This package contains documentation for Qt Creator IDE.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export QT_SELECT := qt5

# Upstream changelog
upstream_changes = $(wildcard dist/changes-*)

# Do build the HelloWorld plugin, as it is not needed
export QTC_BUILD_PLUGIN_HELLOWORLD=FALSE
# Do not build the ClangFormat plugin, as it requires clang-format with
# a patch not accepted yet (and available only in the QtC fork):
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=939825#49
# https://bugreports.qt.io/browse/QTCREATORBUG-22923
# https://reviews.llvm.org/D53072
export QTC_BUILD_PLUGIN_CLANGFORMAT=FALSE

# The clang-N used for the build by the unversioned clang
current_clang_pkg = $(shell dpkg -S "$(shell realpath $(shell env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang))" | cut -d: -f1)
# The upstream version of a package passed as parameter
upstream_version_of_pkg = $(shell dpkg-query -f '$${Version}' -W $(1) | sed -e 's/-[^-]*$$//')

%:
	dh $@ --builddirectory=builddir

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_DEVELOPER_DOCS=ON \
		-DBUILD_QBS=OFF \
		-DWITH_DOCS=$(if $(filter qtcreator-doc, $(shell dh_listpackages)),ON,OFF)

execute_after_dh_auto_build-indep:
	dh_auto_build -- docs

override_dh_auto_install:
	dh_auto_install
ifneq (,$(filter qtcreator-doc, $(shell dh_listpackages)))
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component qch_docs
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component html_docs
endif

	# Not needed
	rm debian/tmp/usr/bin/qtcreator.sh

	# Remove extra exec permissions
	find debian/tmp -name qmldir -type f -exec chmod -x {} \;

override_dh_install:
	dh_install
	# Copied in qtcreator-doc already
	rm -rf debian/qtcreator-data/usr/share/qtcreator/doc/

override_dh_installdocs:
	dh_installdocs -pqtcreator-data $(upstream_changes)
	dh_installdocs --remaining-packages

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/

override_dh_shlibdeps:
	echo 'libQt5DesignerComponents 5 libqt5designercomponents5 (>= $(call upstream_version_of_pkg,libqt5designercomponents5)~)' > debian/shlibs.local
	dh_shlibdeps -l$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator:\
	$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/plugins/QtProject
	rm debian/shlibs.local

override_dh_gencontrol-arch:
	dh_gencontrol -a -- -V'qtcreator:clang=$(current_clang_pkg) (>= $(call upstream_version_of_pkg,$(current_clang_pkg))~)'
